<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleEMGTracking.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleEMGTracking_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleEMGTracking.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example that uses the MocoInverse tool and EMG data to create an EMG-driven simulation of walking. This example is used in hands-on workshops, and accordingly has blanks that users must fill in. See <a class="el" href="exampleSquatToStand_answers_8m-example.html">exampleSquatToStand_answers.m</a> for a completed version.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">import</span> exampleEMGTracking_helpers <span class="keyword">as</span> helpers</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">import</span> numpy <span class="keyword">as</span> np</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"># Part 1a: Load a 19 degree-of-freedom model with 18 lower-limb,</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># sagittal-plane muscles and a torque-actuated torso. This includes a set of</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># ground reaction forces applied to the model via ExternalLoads, which is</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># necessary for the muscle redundancy problem. See the function definition</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># at the bottom of this file to see how the model is loaded and constructed.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;model = helpers.getWalkingModel()</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"># Part 1b: Create the MocoInverse tool and set the Model.</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"># Part 1c: Create a TableProcessor using the coordinates file from inverse</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"># kinematics.</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"># Part 1d: Set the kinematics reference for MocoInverse using the</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"># TableProcessor we just created.</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"># Part 1e: Provide the solver settings: initial and final time, the mesh</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"># interval, and the constraint and convergence tolerances.</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;inverse.set_initial_time( )</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;inverse.set_final_time( )</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;inverse.set_mesh_interval( )</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;inverse.set_constraint_tolerance( )</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;inverse.set_convergence_tolerance( )</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> os.path.isfile(<span class="stringliteral">&#39;effortSolution.sto&#39;</span>):</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="comment"># Part 1f: Solve the problem!</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;emgReference = osim.TimeSeriesTable(<span class="stringliteral">&#39;emg.sto&#39;</span>)</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;helpers.compareSolutionToEMG(emgReference, <span class="stringliteral">&#39;effortSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment"># Part 3a: Call initialize() to get access to the MocoStudy contained within</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment"># the MocoInverse instance. This will allow us to make additional</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="comment"># modifications to the problem not provided by MocoInverse.</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"># Part 3b: Create a MocoControlTrackingGoal, set its weight, and provide</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment"># the EMG data as the tracking reference. We also need to specify the</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"># reference labels for the four muscles whose EMG we will track.</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;tracking = </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;tracking.setWeight( )</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;tracking.setReference( )</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;tracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/gasmed_l&#39;</span>, <span class="stringliteral">&#39;gastrocnemius&#39;</span>)</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;tracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/tibant_l&#39;</span>, <span class="stringliteral">&#39;tibialis_anterior&#39;</span>)</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;tracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/bfsh_l&#39;</span>, <span class="stringliteral">&#39;biceps_femoris&#39;</span>)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;tracking.setReferenceLabel( )</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment"># Part 3c: The EMG signals in the tracking are all normalized to have</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment"># a maximum value of 1, but the magnitudes of the excitations from the</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"># effort minimization solution suggest that these signals should be</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"># rescaled. Use addScaleFactor() to add a MocoParameter to the problem that</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment"># will scale the reference data for the muscles in the tracking cost.</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;tracking.addScaleFactor(<span class="stringliteral">&#39;gastroc_factor&#39;</span>, <span class="stringliteral">&#39;/forceset/gasmed_l&#39;</span>, [0.01, 1.0])</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;tracking.addScaleFactor(<span class="stringliteral">&#39;tibant_factor&#39;</span>, <span class="stringliteral">&#39;/forceset/tibant_l&#39;</span>, [0.01, 1.0])</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;tracking.addScaleFactor(<span class="stringliteral">&#39;bifem_factor&#39;</span>, <span class="stringliteral">&#39;/forceset/bfsh_l&#39;</span>, [0.01, 1.0])</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;tracking.addScaleFactor( )</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment"># Part 3d: Add the tracking goal to the problem.</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment"># Part 3e: Update the MocoCasADiSolver with the updated MocoProblem using</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment"># resetProblem().</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;solver = osim.MocoCasADiSolver.safeDownCast(study.updSolver())</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;solver.resetProblem(problem)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment"># Part 3f: Tell MocoCasADiSolver that the MocoParameters we added to the</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment"># problem via addScaleFactor() above do not require initSystem() calls on</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment"># the model. This provides a large speed-up.</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keywordflow">if</span> <span class="keywordflow">not</span> os.path.isfile(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>):</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="comment"># Part 3g: Solve the problem!</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment"># Part 3h: Get the values of the optimized scale factors.</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;trackingSolution = osim.MocoTrajectory(<span class="stringliteral">&#39;trackingSolution.sto&#39;</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;gastroc_factor = trackingSolution.getParameter(<span class="stringliteral">&#39;gastroc_factor&#39;</span>)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;tibant_factor = trackingSolution.getParameter(<span class="stringliteral">&#39;tibant_factor&#39;</span>)</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;bifem_factor = trackingSolution.getParameter(<span class="stringliteral">&#39;bifem_factor&#39;</span>)</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;gluteus_factor = </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;print(<span class="stringliteral">&#39;\nOptimized scale factor values:&#39;</span>)</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;print(<span class="stringliteral">&#39;------------------------------&#39;</span>)</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;print(<span class="stringliteral">&#39;gastrocnemius = &#39;</span> + str(gastroc_factor))</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;print(<span class="stringliteral">&#39;tibialis anterior = &#39;</span> + str(tibant_factor))</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;print(<span class="stringliteral">&#39;biceps femoris short head = &#39;</span> + str(bifem_factor))</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;print(<span class="stringliteral">&#39;gluteus = &#39;</span> + str(gluteus_factor))</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment"># Part 4b: Re-scale the reference data using the optimized scale factors.</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;gastroc = emgReference.updDependentColumn(<span class="stringliteral">&#39;gastrocnemius&#39;</span>)</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;tibant = emgReference.updDependentColumn(<span class="stringliteral">&#39;tibialis_anterior&#39;</span>)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;bifem = emgReference.updDependentColumn(<span class="stringliteral">&#39;biceps_femoris&#39;</span>)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;gluteus = emgReference.updDependentColumn(<span class="stringliteral">&#39;gluteus&#39;</span>)</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keywordflow">for</span> t <span class="keywordflow">in</span> np.arange(emgReference.getNumRows()):</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    t = int(t) <span class="comment"># Convert to Python built-in int type for indexing</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    gastroc[t] = gastroc_factor * gastroc[t]</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    tibant[t] = tibant_factor * tibant[t]</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    bifem[t] = bifem_factor * bifem[t]</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    gluteus[t] = gluteus_factor * gluteus[t]</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160; </div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="comment"># Part 4c: Generate the plots. Compare results to the effort minimization</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="comment"># solution.</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;helpers.compareSolutionToEMG(emgReference, <span class="stringliteral">&#39;effortSolution.sto&#39;</span>,</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="stringliteral">&#39;trackingSolution.sto&#39;</span>)</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
